Class | Sequel::TimestampMigrator
In: | lib/sequel/extensions/migration.rb
Parent: | Migrator

The migrator used if any migration file version appears to be a timestamp. Stores filenames of migration files, and can figure out which migrations have not been applied and apply them, even if earlier migrations are added after later migrations. If you plan to do that, the responsibility is on you to make sure the migrations don‘t conflict. Part of the `migration` extension.

### Methods

is_current? new run

### Constants

DEFAULT_SCHEMA_COLUMN | = | :filename
DEFAULT_SCHEMA_TABLE | = | :schema_migrations
Error | = | Migrator::Error

### Attributes

applied_migrations | [R] | Array of strings of applied migration filenames
migration_tuples | [R] | Get tuples of migrations, filenames, and actions for each migration

### Public Class methods

new(db, directory, opts={})

Set up all state for the migrator instance

[Source]

         # File lib/sequel/extensions/migration.rb, line 622
    622:     def initialize(db, directory, opts={})
    623:       super
    624:       @target = opts[:target]
    625:       @applied_migrations = get_applied_migrations
    626:       @migration_tuples = get_migration_tuples
    627:     end

### Public Instance methods

is_current?()

The timestamp migrator is current if there are no migrations to apply in either direction.

[Source]

         # File lib/sequel/extensions/migration.rb, line 631
    631:     def is_current?
    632:       migration_tuples.empty?
    633:     end

run()

Apply all migration tuples on the database

[Source]

         # File lib/sequel/extensions/migration.rb, line 636
    636:     def run
    637:       migration_tuples.each do |m, f, direction|
    638:         t = Time.now
    639:         db.log_info("Begin applying migration #{f}, direction: #{direction}")
    640:         checked_transaction(m) do
    641:           m.apply(db, direction)
    642:           fi = f.downcase
    643:           direction == :up ? ds.insert(column=>fi) : ds.filter(column=>fi).delete
    644:         end
    645:         db.log_info("Finished applying migration #{f}, direction: #{direction}, took #{sprintf('%0.6f', Time.now - t)} seconds")
    646:       end
    647:       nil
    648:     end

[Validate]